/*
 * Copyright (C) 2004 by Peter Simons <simons@cryp.to>.
 * All rights reserved.
 */

// // ISO C++ headers.
// #include <cstdio>
// #include <string>
//
// // POSIX.1 system headers.
// #include <sys/types.h>
// #include <unistd.h>
//
// // My own libraries.
// #include "libhashcash/hashcash.h"
// #undef word
// #include "librfc822/rfc822.hh"
// #include "RegExp/RegExp.hh"
// #include "system-error/system-error.hh"
// #include "extract-addresses.hh"
#include "config.hh"
#include "log.hh"
// #include "address-db.hh"
// #include "lines2regex.hh"
// #include "spool.hh"
// #include "deliver.hh"
// #include "request-confirmation.hh"
// #include "gather-addresses.hh"
// #include "accept-confirmation.hh"

using namespace std;

int main(int argc, char** argv)
try
  {
  // Create our configuration.

  config = new configuration(argc, argv);

  // Log the fact we're here.

  debug(("mapSoN-sendmail version " VERSION " starting up"));
  config->dump();

  return 0;
  }
catch(const configuration::no_error&)
  {
  return 0;
  }
// catch(const rfc822_syntax_error& e)
//   {
//   error("Syntax error in '%s': %s",
//         (config) ? config->message_id.c_str() : "no-message-id", e.what());
//   return (config) ? config->syntax_error_rc : 75;
//   }
catch(const exception& e)
  {
  error("'%s': %s",
        (config) ? config->message_id.c_str() : "internal", e.what());
  return (config) ? config->syntax_error_rc : 75;
  }
catch(...)
  {
  error("'%s': Unknown exception; aborting.",
        (config) ? config->message_id.c_str() : "internal");
  return (config) ? config->syntax_error_rc : 75;
  }
